#!/bin/sh
##
# This utility helps to create data types that corresponds to the elements 
# that are there in a particular DTD file. 
# It takes as argument, the cluster member name, userid, password, the name 
# of the DTD file, the name of the super data type and an optional name space 
# prefix that has to be added to these data types
##

INITIAL_MEMORY="32M"

if [ -z "$IMPACT_HOME" ]; then
        echo "IMPACT_HOME environment variable not set, using /opt/netcool/impact."
	IMPACT_HOME=/opt/netcool/impact export IMPACT_HOME
fi

if [ -r $IMPACT_HOME/bin/.nci_wrapper ]; then
	. $IMPACT_HOME/bin/.nci_wrapper
else
	echo "Unable to install as this user.  Please login as someone who has access to $IMPACT_HOME"
	exit 1
fi

# Now we need to determine the RUNTIME from nci_server.
# This is quite ugly....but we are having problems with the RUNTIME
# being hard coded in the DSAs.
eval `grep "RUNTIME=" $IMPACT_HOME/bin/nci_server`

if [ -z "$RUNTIME" ]; then
        echo "RUNTIME could not be determined from $IMPACT_HOME/bin/nci_server script. "
	echo "Please check that $IMPACT_HOME is set to a valid Impact installation.  Exiting."
        exit 1
fi

. $IMPACT_HOME/bin/.nci_wrapper
. $DOLLAR$IMPACT_HOME/platform/$DOLLAR${ARCH}/runtime_def_$DOLLAR${RUNTIME}
. $IMPACT_HOME/lib/build_def
. $IMPACT_HOME/dsa/XmlDsa/dsa_def

case $# in
0) echo "Invalid Arguments for CreateTypes script, should be "; echo " CreateTypes serverName, userId, password, dtdFileName TypeName NameSpacePrefix(optional)";exit;;
1) echo "Invalid Arguments for CreateTypes script, should be "; echo " CreateTypes serverName, userId, password, dtdFileName TypeName NameSpacePrefix(optional)";exit;;
2) echo "Invalid Arguments for CreateTypes script, should be "; echo " CreateTypes serverName, userId, password, dtdFileName TypeName NameSpacePrefix(optional)";exit;;
3) echo "Invalid Arguments for CreateTypes script, should be "; echo " CreateTypes serverName, userId, password, dtdFileName TypeName NameSpacePrefix(optional)";exit;;
4) echo "Invalid Arguments for CreateTypes script, should be "; echo " CreateTypes serverName, userId, password, dtdFileName TypeName NameSpacePrefix(optional)";exit;;
esac

echo "server name is $1"
echo "userid is $2"
echo "dtd file name is  $4"
echo "Type name is $5"
echo "Name space prefix is $6 "

echo "Generating the names of the types into NamesOutPutFile"
$DOLLAR${VM_RUNTIME} $DOLLAR${VM_FLAGS} -Dbase.directory=$DOLLAR${IMPACT_HOME}  -cp $DOLLAR${OPTIONAL_JARS}:$DOLLAR${IMPACT_HOME}/lib/ncsmClient.jar:$DOLLAR${IMPACT_HOME}/lib/$DOLLAR${JAR}.jar:$DOLLAR${IMPACT_HOME}/lib3p/$DOLLAR${JAR3P}.jar:$DOLLAR${IMPACT_HOME}/dsa/XmlDsa/bin/XmlMediatorUtil.jar com.micromuse.dsa.XmlDsa.DTDParser $DOLLAR$4 NameOutputFile

echo "Adding types and Data source into Impact"
$DOLLAR${VM_RUNTIME} $DOLLAR${VM_FLAGS} -Dbase.directory=$DOLLAR${IMPACT_HOME}  -Dname=$DOLLAR$1 -cp $DOLLAR${OPTIONAL_JARS}:$DOLLAR${IMPACT_HOME}/lib/ncsmClient.jar:$DOLLAR${IMPACT_HOME}/lib/$DOLLAR${JAR}.jar:$DOLLAR${IMPACT_HOME}/lib3p/$DOLLAR${JAR3P}.jar:$DOLLAR${IMPACT_HOME}/dsa/XmlDsa/bin/XmlMediatorUtil.jar com.micromuse.dsa.XmlDsa.CreateXmlTypesHelper $DOLLAR$2 $DOLLAR$3 NameOutputFile XmlDsaMediatorDataSource $DOLLAR$5 $DOLLAR$6

rm NameOutputFile
